
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Question_answersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const question_answers = await db.question_answers.create(
            {
                id: data.id || undefined,
        
        answer_text: data.answer_text
        ||
        null
            ,
            
        is_correct: data.is_correct
        ||
        false
        
            ,
            
        order_index: data.order_index
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await question_answers.setQuestion( data.question || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.question_answers.getTableName(),
                belongsToColumn: 'answer_images',
                belongsToId: question_answers.id,
            },
            data.answer_images,
            options,
        );
        

        return question_answers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const question_answersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                answer_text: item.answer_text
            ||
            null
            ,
            
                is_correct: item.is_correct
            ||
            false
        
            ,
            
                order_index: item.order_index
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const question_answers = await db.question_answers.bulkCreate(question_answersData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < question_answers.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.question_answers.getTableName(),
                    belongsToColumn: 'answer_images',
                    belongsToId: question_answers[i].id,
                },
                data[i].answer_images,
                options,
            );
        }
        

        return question_answers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const question_answers = await db.question_answers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.answer_text !== undefined) updatePayload.answer_text = data.answer_text;
        
        
        if (data.is_correct !== undefined) updatePayload.is_correct = data.is_correct;
        
        
        if (data.order_index !== undefined) updatePayload.order_index = data.order_index;
        
        
        updatePayload.updatedById = currentUser.id;

        await question_answers.update(updatePayload, {transaction});

        
        
        if (data.question !== undefined) {
            await question_answers.setQuestion(
              
              data.question,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.question_answers.getTableName(),
                belongsToColumn: 'answer_images',
                belongsToId: question_answers.id,
            },
            data.answer_images,
            options,
        );
        

        return question_answers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const question_answers = await db.question_answers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of question_answers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of question_answers) {
                await record.destroy({transaction});
            }
        });


        return question_answers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const question_answers = await db.question_answers.findByPk(id, options);

        await question_answers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await question_answers.destroy({
            transaction
        });

        return question_answers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const question_answers = await db.question_answers.findOne(
            { where },
            { transaction },
        );

        if (!question_answers) {
            return question_answers;
        }

        const output = question_answers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.player_answers_selected_answer = await question_answers.getPlayer_answers_selected_answer({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        output.question = await question_answers.getQuestion({
            transaction
        });
        
        
        output.answer_images = await question_answers.getAnswer_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.quiz_questions,
        as: 'question',
        
        where: filter.question ? {
          [Op.or]: [
            { id: { [Op.in]: filter.question.split('|').map(term => Utils.uuid(term)) } },
            {
              prompt: {
                [Op.or]: filter.question.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'answer_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.answer_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'question_answers',
                        'answer_text',
                        filter.answer_text,
                    ),
                };
            }
            

            
            

            
            if (filter.order_indexRange) {
                const [start, end] = filter.order_indexRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    order_index: {
                    ...where.order_index,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    order_index: {
                    ...where.order_index,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_correct) {
                where = {
                    ...where,
                is_correct: filter.is_correct,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.question_answers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'question_answers',
                        'answer_text',
                        query,
                    ),
                ],
            };
        }

        const records = await db.question_answers.findAll({
            attributes: [ 'id', 'answer_text' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['answer_text', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.answer_text,
        }));
    }

    
};

